CREATE TABLE ###TBLPREFIX###tblIndex (
  DID int(11) unsigned NOT NULL default '0',
  `Text` text NOT NULL,
  ID bigint(20) unsigned NOT NULL default '0',
  OID bigint(20) unsigned NOT NULL default '0',
  BText longtext NOT NULL,
  Workspace varchar(1000) NOT NULL default '',
  WorkspaceID bigint(20) unsigned NOT NULL default '0',
  Category varchar(255) NOT NULL default '',
  ClassID bigint(20) unsigned NOT NULL default '0',
  Doctype bigint(20) unsigned NOT NULL default '0',
  Title varchar(255) NOT NULL default '',
  Description text NOT NULL,
  Path varchar(255) NOT NULL default '',
  Language varchar(5) default NULL,
  PRIMARY KEY (`DID`,`OID`,WorkspaceID),
  KEY `OID` (`OID`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblwidgetnotepad (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `WidgetName` varchar(100) NOT NULL default '',
  `UserID` int(10) unsigned NOT NULL default '0',
  `CreationDate` date NOT NULL default '0000-00-00',
  `Title` varchar(255) NOT NULL default '',
  `Text` text NOT NULL,
  `Priority` enum('low','medium','high') NOT NULL default 'low',
  `Valid` enum('always','date','period') NOT NULL default 'always',
  `ValidFrom` date NOT NULL default '0000-00-00',
  `ValidUntil` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM;
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblwidgetnotepad VALUES (1, 'webEdition', 1, NOW(), 'Welcome to webEdition!', '', 'low', 'always', NOW(), "3000-01-01");
/* query separator */
CREATE TABLE ###TBLPREFIX###tblnavigationrules (
  ID int(11) unsigned NOT NULL auto_increment,
  NavigationName varchar(255) default NULL,
  NavigationID int(11) unsigned NOT NULL default '0',
  SelectionType varchar(16) NOT NULL default '',
  FolderID int(11) unsigned NOT NULL default '0',
  DoctypeID int(11) unsigned NOT NULL default '0',
  Categories text NOT NULL,
  ClassID int(11) unsigned NOT NULL default '0',
  WorkspaceID int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowLog (
  ID bigint(20) unsigned NOT NULL auto_increment,
  RefID bigint(20) unsigned NOT NULL default '0',
  docTable varchar(255) NOT NULL default '',
  userID bigint(20) unsigned NOT NULL default '0',
  logDate bigint(10) unsigned NOT NULL default '0',
  `Type` tinyint(4) unsigned NOT NULL default '0',
  Description varchar(255) NOT NULL default '',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY###CREATE TEMPORARY TABLE IF NOT EXISTS _newNewsPref(
  pref_name varchar(30) NOT NULL default '',
  pref_value longtext NOT NULL,
  PRIMARY KEY name (pref_name(30))
)ENGINE = MYISAM;
/* query separator */
###UPDATEONLY###INSERT IGNORE INTO _newNewsPref SELECT DISTINCT * FROM ###TBLPREFIX###tblNewsletterPrefs GROUP BY pref_name;
/* query separator */
###UPDATEONLY###TRUNCATE ###TBLPREFIX###tblNewsletterPrefs;
/* query separator */
###UPDATEONLY###INSERT INTO ###TBLPREFIX###tblNewsletterPrefs SELECT * FROM _newNewsPref;
/* query separator */

###UPDATEONLY###DROP TEMPORARY TABLE IF EXISTS _newNewsPref;
/* query separator */

CREATE TABLE ###TBLPREFIX###tblNewsletterPrefs (
  pref_name varchar(30) NOT NULL default '',
  pref_value longtext NOT NULL,
  PRIMARY KEY (pref_name)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblNewsletterLog (
  ID bigint(20) unsigned NOT NULL auto_increment,
  NewsletterID bigint(20) unsigned NOT NULL default '0',
  LogTime bigint(20) unsigned NOT NULL default '0',
  Log varchar(255) NOT NULL default '',
  Param varchar(255) NOT NULL default '',
  PRIMARY KEY  (ID),
  KEY NewsletterID (NewsletterID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblbannerprefs (
  pref_name varchar(255) NOT NULL,
  pref_value varchar(255) NOT NULL default '',
  PRIMARY KEY  (pref_name)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowStep (
  ID int(11) unsigned NOT NULL auto_increment,
  `Worktime` float NOT NULL default '0',
  timeAction tinyint(1) unsigned NOT NULL default '0',
  stepCondition int(11) unsigned NOT NULL default '0',
  workflowID int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMsgSettings (
  ID int(11) unsigned NOT NULL auto_increment,
  UserID int(11) unsigned NOT NULL default '0',
  strKey varchar(255) default NULL,
  strVal varchar(255) default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblContentTypes (
  OrderNr int(11) unsigned NOT NULL default '0',
  ContentType varchar(32) NOT NULL default '',
  Extension varchar(128) NOT NULL default '',
  DefaultCode text NOT NULL,
  IconID int(11) unsigned NOT NULL default '0',
  Template tinyint(4) unsigned NOT NULL default '0',
  `File` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ContentType)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblNewsletterBlock (
  ID bigint(20) unsigned NOT NULL auto_increment,
  NewsletterID bigint(20) unsigned NOT NULL default '0',
  Groups varchar(255) NOT NULL default '',
  `Type` tinyint(4) unsigned NOT NULL default '0',
  LinkID bigint(20) unsigned NOT NULL default '0',
  Field varchar(255) NOT NULL default '',
  Source longtext NOT NULL,
  Html longtext NOT NULL,
  Pack tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY NewsletterID (NewsletterID)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY### UPDATE ###TBLPREFIX###tblWebUser SET Path=CONCAT("/",Username) WHERE SUBSTR(Path,1,1)!="/"
/* query separator */

CREATE TABLE ###TBLPREFIX###tblWebUser (
  ID bigint(20) unsigned NOT NULL auto_increment,
  Username varchar(255) NOT NULL default '',
  `Password` varchar(255) NOT NULL default '',
  `Anrede_Anrede` enum('','Herr','Frau') NOT NULL,
  Anrede_Titel varchar(200) NOT NULL default '',
  Forename varchar(128) NOT NULL default '',
  Surname varchar(128) NOT NULL default '',
  LoginDenied tinyint(1) unsigned NOT NULL default '0',
  MemberSince int(10) unsigned NOT NULL default '0',
  LastLogin int(10) unsigned NOT NULL default '0',
  LastAccess int(10) unsigned NOT NULL default '0',
  AutoLoginDenied tinyint(1) unsigned NOT NULL default '0',
  AutoLogin tinyint(1) unsigned NOT NULL default '0',
  ModifyDate bigint(20) unsigned NOT NULL default '0',
  `ModifiedBy` enum('','backend','frontend','external') NOT NULL default'',
  ParentID bigint(20) unsigned NOT NULL default '0',
  Path varchar(255) default NULL,
  IsFolder tinyint(1) unsigned default NULL,
  Icon varchar(255) default NULL,
  `Text` varchar(255) default NULL,
  `Newsletter_Ok` enum('','ja','0','1','2') NOT NULL,
  `Newsletter_HTMLNewsletter` enum('','ja','0','1','2') NOT NULL,
  PRIMARY KEY  (ID),
  UNIQUE KEY `Username` (`Username`),
  KEY Surname (Surname(3))
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblexport (
  ID bigint(20) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Icon varchar(255) NOT NULL default '',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  Path varchar(255) NOT NULL default '',
  ExportTo varchar(255) NOT NULL default '',
  ServerPath varchar(255) NOT NULL default '',
  Filename varchar(255) NOT NULL default '',
  Selection varchar(255) NOT NULL default '',
  SelectionType varchar(255) NOT NULL default '',
  DocType varchar(255) NOT NULL default '',
  Folder bigint(20) unsigned NOT NULL default '0',
  ClassName varchar(255) NOT NULL default '',
  Categorys text NOT NULL,
  selDocs text NOT NULL,
  selTempl text NOT NULL,
  selObjs text NOT NULL,
  selClasses text NOT NULL,
  HandleDefTemplates tinyint(1) unsigned NOT NULL default '0',
  HandleDocIncludes tinyint(1) unsigned NOT NULL default '0',
  HandleObjIncludes tinyint(1) unsigned NOT NULL default '0',
  HandleDocLinked tinyint(1) unsigned NOT NULL default '0',
  HandleDefClasses tinyint(1) unsigned NOT NULL default '0',
  HandleObjEmbeds tinyint(1) unsigned NOT NULL default '0',
  HandleDoctypes tinyint(1) unsigned NOT NULL default '0',
  HandleCategorys tinyint(1) unsigned NOT NULL default '0',
  ExportDepth varchar(255) NOT NULL default '',
  HandleOwners tinyint(1) unsigned NOT NULL default '0',
  HandleNavigation tinyint(1) unsigned NOT NULL default '0',
  HandleThumbnails tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblFile (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Icon enum('','pdf.gif','zip.gif','word.gif','excel.gif','powerpoint.gif','prog.gif','link.gif','image.gif','html.gif','we_dokument.gif','javascript.gif','css.gif','htaccess.gif','folder.gif','flashmovie.gif','quicktime.gif','odg.gif') NOT NULL,
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  ContentType enum('','image/*','text/html','text/webedition','text/js','text/css','text/htaccess','text/plain','folder','application/x-shockwave-flash','application/*','video/quicktime','application/*','text/xml') NOT NULL default '',
  CreationDate int(11) unsigned NOT NULL default '0',
  ModDate int(11) unsigned NOT NULL default '0',
  `Path` varchar(255) NOT NULL default '',
  TemplateID int(11) unsigned NOT NULL default '0',
  temp_template_id int(11) unsigned NOT NULL default '0',
  Filename varchar(255) NOT NULL default '',
  Extension varchar(16) NOT NULL default '',
  IsDynamic tinyint(1) unsigned NOT NULL default '0',
  IsSearchable tinyint(1) unsigned NOT NULL default '0',
  DocType smallint(6) NOT NULL,
  temp_doc_type smallint(6) NOT NULL,
  ClassName varchar(64) NOT NULL default '',
  Category text NULL default NULL,
  temp_category text NULL default NULL,
  Deleted int(11) unsigned NOT NULL default '0',
  Published int(11) unsigned NOT NULL default '0',
  CreatorID bigint(20) unsigned NOT NULL default '0',
  ModifierID bigint(20) unsigned NOT NULL default '0',
  RestrictOwners tinyint(1) unsigned NOT NULL default '0',
  Owners varchar(255) NOT NULL default '',
  OwnersReadOnly text NOT NULL,
  documentArray text NOT NULL,
  `Language` varchar(5) NOT NULL default '',
  WebUserID bigint(20) unsigned NOT NULL default '0',
  listview tinyint(1) unsigned NOT NULL default '0',
  InGlossar tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Path (Path),
  KEY WebUserID (WebUserID)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY###DELETE FROM ###TBLPREFIX###tblcustomerfilter WHERE modelTable="";
/* query separator */

CREATE TABLE ###TBLPREFIX###tblcustomerfilter (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `modelId` bigint(20) unsigned NOT NULL,
  `modelType` enum('folder','objectFile','text/webedition')  NOT NULL,
  `modelTable` enum('tblFile','tblObjectFiles') NOT NULL,
  `accessControlOnTemplate` tinyint(1) unsigned NOT NULL default '0',
  `errorDocNoLogin` bigint(20) unsigned NOT NULL default '0',
  `errorDocNoAccess` bigint(20) unsigned NOT NULL default '0',
  `mode` tinyint(4) unsigned NOT NULL default '0',
  `specificCustomers` text NOT NULL,
  `filter` text NOT NULL,
  `whiteList` text NOT NULL,
  `blackList` text NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `mode` (`mode`),
  UNIQUE KEY `modelIdN` (`modelId`,`modelType`,`modelTable`),
  KEY modelType (modelType,accessControlOnTemplate)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY###CREATE TEMPORARY TABLE IF NOT EXISTS _tblWebAdmin(
  Name varchar(255) NOT NULL default '',
  `Value` text NOT NULL,
  PRIMARY KEY (Name)
)ENGINE = MYISAM;
/* query separator */
###UPDATEONLY###INSERT IGNORE INTO _tblWebAdmin SELECT DISTINCT * FROM ###TBLPREFIX###tblWebAdmin GROUP BY Name;
/* query separator */
###UPDATEONLY###TRUNCATE ###TBLPREFIX###tblWebAdmin;
/* query separator */
###UPDATEONLY###INSERT INTO ###TBLPREFIX###tblWebAdmin SELECT * FROM _tblWebAdmin;
/* query separator */

###UPDATEONLY###DROP TEMPORARY TABLE IF EXISTS _tblWebAdmin;
/* query separator */

CREATE TABLE ###TBLPREFIX###tblWebAdmin (
  Name varchar(255) NOT NULL default '',
  `Value` text NOT NULL,
  PRIMARY KEY (Name)
) ENGINE=MyISAM;
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblWebAdmin VALUES ('FieldAdds','a:13:{s:8:"Username";a:1:{s:4:"type";s:5:"input";}s:8:"Password";a:1:{s:4:"type";s:5:"input";}s:8:"Forename";a:1:{s:4:"type";s:5:"input";}s:7:"Surname";a:1:{s:4:"type";s:5:"input";}s:11:"LoginDenied";a:1:{s:4:"type";s:5:"input";}s:11:"MemberSince";a:1:{s:4:"type";s:5:"input";}s:9:"LastLogin";a:1:{s:4:"type";s:5:"input";}s:10:"LastAccess";a:1:{s:4:"type";s:5:"input";}s:15:"AutoLoginDenied";a:1:{s:4:"type";s:5:"input";}s:9:"AutoLogin";a:1:{s:4:"type";s:5:"input";}s:13:"Anrede_Anrede";a:2:{s:7:"default";s:10:",Herr,Frau";s:4:"type";s:6:"select";}s:13:"Newsletter_Ok";a:2:{s:7:"default";s:3:",ja";s:4:"type";s:6:"select";}s:25:"Newsletter_HTMLNewsletter";a:2:{s:7:"default";s:3:",ja";s:4:"type";s:6:"select";}}');
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblWebAdmin VALUES ('Prefs','a:4:{s:10:"start_year";s:4:"1900";s:17:"default_sort_view";s:20:"--Keine Sortierung--";s:15:"treetext_format";s:30:"#Username (#Forename #Surname)";s:13:"default_order";s:0:"";}');
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblWebAdmin VALUES ('SortView','');
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblWebAdmin VALUES ('default_saveRegisteredUser_register','false');
/* query separator */
CREATE TABLE ###TBLPREFIX###tblAnzeigePrefs (
  ID smallint(5) unsigned NOT NULL auto_increment,
  strDateiname varchar(255) NOT NULL default '',
  strFelder text NOT NULL,
  PRIMARY KEY  (ID),
  UNIQUE KEY `strDateiname` (`strDateiname`)
) ENGINE=MyISAM;
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblAnzeigePrefs VALUES (1,'edit_shop_properties','a:2:{s:14:"customerFields";a:0:{}s:19:"orderCustomerFields";a:0:{}}');
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblAnzeigePrefs VALUES (2,'shop_pref','€|19|german');
/* query separator */
CREATE TABLE ###TBLPREFIX###tblContent (
  ID bigint(20) unsigned NOT NULL auto_increment,
  BDID int(11) unsigned NOT NULL default '0',
  Dat longtext,
  IsBinary tinyint(1) unsigned NOT NULL default '0',
  AutoBR char(3) NOT NULL default '',
  LanguageID int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY BDID (BDID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMetadata (
  `id` int(11) unsigned NOT NULL auto_increment,
  `tag` varchar(255) NOT NULL,
  `type` varchar(255) NOT NULL,
  `importFrom` varchar(255) NOT NULL,
  PRIMARY KEY  (`id`)
)  ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblUpdateLog (
  ID int(11) unsigned NOT NULL auto_increment,
  dortigeID int(11) unsigned NOT NULL default '0',
  datum datetime default NULL,
  aktion text NOT NULL,
  versionsnummer varchar(10) NOT NULL default '',
  module text NOT NULL,
  error tinyint(1) unsigned NOT NULL default '0',
  step smallint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblNewsletterGroup (
  ID bigint(20) unsigned NOT NULL auto_increment,
  NewsletterID bigint(20) NOT NULL default '0',
  Emails longtext NOT NULL,
  Customers longtext NOT NULL,
  SendAll tinyint(1) unsigned NOT NULL default '0',
  Filter blob NOT NULL,
  Extern longtext,
  PRIMARY KEY (ID),
  KEY NewsletterID (NewsletterID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblNewsletter (
  ID bigint(20) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  Icon varchar(255) NOT NULL default '',
  Path varchar(255) NOT NULL default '',
  `Text` varchar(255) NOT NULL default '',
  `Subject` varchar(255) NOT NULL default '',
  Sender varchar(255) NOT NULL default '',
  Reply varchar(255) NOT NULL default '',
  Test varchar(255) NOT NULL default '',
  Log text NOT NULL,
  Step int(11) unsigned NOT NULL default '0',
  `Offset` int(11) unsigned NOT NULL default '0',
  `Charset` varchar(255) NOT NULL default '',
  isEmbedImages tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY###CREATE TEMPORARY TABLE IF NOT EXISTS _delKeys(
  ID bigint unsigned
)ENGINE = MEMORY;

/* query separator */
###UPDATEONLY###INSERT INTO _delKeys SELECT s.ID FROM ###TBLPREFIX###tblsearchtool s, ###TBLPREFIX###tblsearchtool t WHERE s.Path=t.Path AND s.ID>t.ID;
/* query separator */
###UPDATEONLY###DELETE FROM ###TBLPREFIX###tblsearchtool WHERE ID IN (SELECT ID FROM _delKeys);
/* query separator */

###UPDATEONLY###DROP TEMPORARY TABLE IF EXISTS _delKeys;
/* query separator */

CREATE TABLE ###TBLPREFIX###tblsearchtool (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `ParentID` bigint(20) unsigned NOT NULL default '0',
  `IsFolder` tinyint(1) unsigned NOT NULL default '0',
  `Icon` varchar(255) NOT NULL,
  `Path` varchar(255) NOT NULL,
  `Text` varchar(255) NOT NULL,
  `predefined` tinyint(1) unsigned NOT NULL,
  `folderIDDoc` int(11) unsigned NOT NULL,
  `folderIDTmpl` int(11) unsigned NOT NULL,
  `searchDocSearch` varchar(255) NOT NULL,
  `searchTmplSearch` varchar(255) NOT NULL,
  `searchForTextDocSearch` varchar(255) NOT NULL,
  `searchForTitleDocSearch` tinyint(1) unsigned NOT NULL,
  `searchForContentDocSearch` varchar(255) NOT NULL,
  `searchForTextTmplSearch` varchar(255) NOT NULL,
  `searchForContentTmplSearch` varchar(255) NOT NULL,
  `anzahlDocSearch` tinyint(4) unsigned NOT NULL,
  `anzahlTmplSearch` tinyint(4) unsigned NOT NULL,
  `anzahlAdvSearch` tinyint(4) unsigned NOT NULL,
  `setViewDocSearch` tinyint(1) unsigned NOT NULL,
  `setViewTmplSearch` tinyint(1) unsigned NOT NULL,
  `setViewAdvSearch` tinyint(1) unsigned NOT NULL,
  `OrderDocSearch` varchar(64) NOT NULL,
  `OrderTmplSearch` varchar(64) NOT NULL,
  `OrderAdvSearch` varchar(64) NOT NULL,
  `searchAdvSearch` varchar(255) NOT NULL,
  `locationAdvSearch` varchar(255) NOT NULL,
  `searchFieldsAdvSearch` varchar(255) NOT NULL,
  `search_tables_advSearch` varchar(255) NOT NULL,
  `activTab` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`ID`),
  UNIQUE KEY Path (Path)
) ENGINE=MyISAM ;
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblsearchtool (`ParentID`, `IsFolder`, `Icon`, `Path`, `Text`, `predefined`, `folderIDDoc`, `folderIDTmpl`, `searchDocSearch`, `searchTmplSearch`, `searchForTextDocSearch`, `searchForTitleDocSearch`, `searchForContentDocSearch`, `searchForTextTmplSearch`, `searchForContentTmplSearch`, `anzahlDocSearch`, `anzahlTmplSearch`, `anzahlAdvSearch`, `setViewDocSearch`, `setViewTmplSearch`, `setViewAdvSearch`, `OrderDocSearch`, `OrderTmplSearch`, `OrderAdvSearch`, `searchAdvSearch`, `locationAdvSearch`, `searchFieldsAdvSearch`, `search_tables_advSearch`, `activTab`) VALUES
(0, 1, 'folder.gif', '/Vordefinierte Suchanfragen', 'Vordefinierte Suchanfragen', 1, 0, 0, '', '', '', 0, '', '', '', 0, 0, 0, 0, 0, 0, '', '', '', '', '', '', '',4),
(1, 1, 'folder.gif', '/Vordefinierte Suchanfragen/Dokumente', 'Dokumente', 1, 0, 0, '', '', '', 0, '', '', '', 0, 0, 0, 0, 0, 0, '', '', '', '', '', '', '',4),
(1, 1, 'folder.gif', '/Vordefinierte Suchanfragen/Objekte', 'Objekte', 1, 0, 0, '', '', '', 0, '', '', '', 0, 0, 0, 0, 0, 0, '', '', '', '', '', '', '',4),
(2, 0, 'Suche.gif', '/Vordefinierte Suchanfragen/Dokumente/Unveroeffentlichte Dokumente', 'Unveroeffentlichte Dokumente', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 25, 25, 25, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:17:"geparkt_geaendert";}', 's:24:"a:1:{i:0;s:7:"CONTAIN";}";', 'a:1:{i:0;s:6:"Status";}', 'a:4:{s:7:"tblFile";s:1:"1";s:14:"tblObjectFiles";s:1:"0";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3),
(2, 0, 'Suche.gif', '/Vordefinierte Suchanfragen/Dokumente/Statische Dokumente', 'Statische Dokumente', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 25, 25, 25, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:8:"statisch";}', 's:32:"s:24:"a:1:{i:0;s:7:"CONTAIN";}";";', 'a:1:{i:0;s:11:"Speicherart";}', 'a:4:{s:7:"tblFile";s:1:"1";s:14:"tblObjectFiles";s:1:"0";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3),
(2, 0, 'Suche.gif', '/Vordefinierte Suchanfragen/Dokumente/Dynamische Dokumente', 'Dynamische Dokumente', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 25, 25, 25, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:9:"dynamisch";}', 's:32:"s:24:"a:1:{i:0;s:7:"CONTAIN";}";";', 'a:1:{i:0;s:11:"Speicherart";}', 'a:4:{s:7:"tblFile";s:1:"1";s:14:"tblObjectFiles";s:1:"0";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3),
(3, 0, 'Suche.gif', '/Vordefinierte Suchanfragen/Objekte/Unveroeffentlichte Objekte', 'Unveroeffentlichte Objekte', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 25, 25, 25, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:17:"geparkt_geaendert";}', 'a:1:{i:0;s:7:"CONTAIN";}', 'a:1:{i:0;s:6:"Status";}', 'a:4:{s:7:"tblFile";s:1:"0";s:14:"tblObjectFiles";s:1:"1";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3),
(0, 1, 'folder.gif', '/Eigene Suchanfragen', 'Eigene Suchanfragen', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '0', 0, '0', '0', '0', 10, 10, 10, 0, 0, 0, '', '', '', 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:7:"CONTAIN";}', 'a:1:{i:0;s:2:"ID";}', 'a:4:{s:7:"tblFile";s:1:"1";s:14:"tblobjectFiles";s:1:"1";s:12:"tblTemplates";s:1:"0";s:9:"tblobject";s:1:"0";}', 4);
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblsearchtool (`ParentID`, `IsFolder`, `Icon`, `Path`, `Text`, `predefined`, `folderIDDoc`, `folderIDTmpl`, `searchDocSearch`, `searchTmplSearch`, `searchForTextDocSearch`, `searchForTitleDocSearch`, `searchForContentDocSearch`, `searchForTextTmplSearch`, `searchForContentTmplSearch`, `anzahlDocSearch`, `anzahlTmplSearch`, `anzahlAdvSearch`, `setViewDocSearch`, `setViewTmplSearch`, `setViewAdvSearch`, `OrderDocSearch`, `OrderTmplSearch`, `OrderAdvSearch`, `searchAdvSearch`, `locationAdvSearch`, `searchFieldsAdvSearch`, `search_tables_advSearch`, `activTab`) VALUES
(0, 1, 'folder.gif', '/Versionen', 'Versionen', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '0', 0, '0', '0', '0', 10, 10, 10, 0, 0, 0, '', '', '', 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:7:"CONTAIN";}', 'a:1:{i:0;s:2:"ID";}', 'a:4:{s:7:"tblFile";s:1:"1";s:14:"tblobjectFiles";s:1:"1";s:12:"tblTemplates";s:1:"0";s:9:"tblobject";s:1:"0";}',4);
/* query separator */
###INSTALLONLY###SELECT @vid:=ID FROM ###TBLPREFIX###tblsearchtool WHERE Path='/Versionen' LIMIT 0,1;
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblsearchtool (`ParentID`, `IsFolder`, `Icon`, `Path`, `Text`, `predefined`, `folderIDDoc`, `folderIDTmpl`, `searchDocSearch`, `searchTmplSearch`, `searchForTextDocSearch`, `searchForTitleDocSearch`, `searchForContentDocSearch`, `searchForTextTmplSearch`, `searchForContentTmplSearch`, `anzahlDocSearch`, `anzahlTmplSearch`, `anzahlAdvSearch`, `setViewDocSearch`, `setViewTmplSearch`, `setViewAdvSearch`, `OrderDocSearch`, `OrderTmplSearch`, `OrderAdvSearch`, `searchAdvSearch`, `locationAdvSearch`, `searchFieldsAdvSearch`, `search_tables_advSearch`, `activTab`) VALUES
(@vid, 1, 'folder.gif', '/Versionen/Dokumente', 'Dokumente', 1, 0, 0, '', '', '', 0, '', '', '', 0, 0, 0, 0, 0, 0, '', '', '', '', '', '', '',4),
(@vid, 1, 'folder.gif', '/Versionen/Objekte', 'Objekte', 1, 0, 0, '', '', '', 0, '', '', '', 0, 0, 0, 0, 0, 0, '', '', '', '', '', '', '',4);
/* query separator */
###INSTALLONLY###SELECT @vdid:=ID FROM ###TBLPREFIX###tblsearchtool WHERE Path='/Versionen/Dokumente' LIMIT 0,1;
/* query separator */
###INSTALLONLY###SELECT @void:=ID FROM ###TBLPREFIX###tblsearchtool WHERE Path='/Versionen/Objekte' LIMIT 0,1;
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblsearchtool (`ParentID`, `IsFolder`, `Icon`, `Path`, `Text`, `predefined`, `folderIDDoc`, `folderIDTmpl`, `searchDocSearch`, `searchTmplSearch`, `searchForTextDocSearch`, `searchForTitleDocSearch`, `searchForContentDocSearch`, `searchForTextTmplSearch`, `searchForContentTmplSearch`, `anzahlDocSearch`, `anzahlTmplSearch`, `anzahlAdvSearch`, `setViewDocSearch`, `setViewTmplSearch`, `setViewAdvSearch`, `OrderDocSearch`, `OrderTmplSearch`, `OrderAdvSearch`, `searchAdvSearch`, `locationAdvSearch`, `searchFieldsAdvSearch`, `search_tables_advSearch`, `activTab`) VALUES
(@vdid, 0, 'Suche.gif', '/Versionen/Dokumente/geloeschte Dokumente', 'gelöschte Dokumente', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 10, 10, 10, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:7:"deleted";}', 'a:1:{i:0;s:7:"CONTAIN";}', 'a:1:{i:0;s:6:"Status";}', 'a:5:{s:7:"tblFile";s:1:"1";s:14:"tblObjectFiles";s:1:"0";s:11:"tblversions";s:1:"1";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3);
/* query separator */
###INSTALLONLY###INSERT IGNORE INTO ###TBLPREFIX###tblsearchtool (`ParentID`, `IsFolder`, `Icon`, `Path`, `Text`, `predefined`, `folderIDDoc`, `folderIDTmpl`, `searchDocSearch`, `searchTmplSearch`, `searchForTextDocSearch`, `searchForTitleDocSearch`, `searchForContentDocSearch`, `searchForTextTmplSearch`, `searchForContentTmplSearch`, `anzahlDocSearch`, `anzahlTmplSearch`, `anzahlAdvSearch`, `setViewDocSearch`, `setViewTmplSearch`, `setViewAdvSearch`, `OrderDocSearch`, `OrderTmplSearch`, `OrderAdvSearch`, `searchAdvSearch`, `locationAdvSearch`, `searchFieldsAdvSearch`, `search_tables_advSearch`, `activTab`) VALUES
(@void, 0, 'Suche.gif', '/Versionen/Objekte/geloeschte Objekte', 'gelöschte Objekte', 1, 0, 0, 'a:1:{i:0;s:0:"";}', 'a:1:{i:0;s:0:"";}', '1', 1, '1', '1', '1', 10, 10, 10, 0, 0, 0, 'Text', 'Text', 'Text', 'a:1:{i:0;s:7:"deleted";}', 'a:1:{i:0;s:7:"CONTAIN";}', 'a:1:{i:0;s:6:"Status";}', 'a:5:{s:7:"tblFile";s:1:"0";s:14:"tblObjectFiles";s:1:"1";s:11:"tblversions";s:1:"1";s:12:"tblTemplates";s:1:"0";s:9:"tblObject";s:1:"0";}',3);
/* query separator */
CREATE TABLE ###TBLPREFIX###tblPrefs (
  userID bigint(20) unsigned NOT NULL default '0',
  FileFilter int(11) unsigned NOT NULL default '0',
  openFolders_tblFile text NOT NULL,
  openFolders_tblTemplates text NOT NULL,
  DefaultTemplateID int(11) unsigned NOT NULL default '0',
  DefaultStaticExt varchar(7) NOT NULL default '',
  DefaultDynamicExt varchar(7) NOT NULL default '',
  DefaultHTMLExt varchar(7) NOT NULL default '',
  sizeOpt tinyint(1) unsigned NOT NULL default '0',
  weWidth smallint unsigned NOT NULL default '0',
  weHeight smallint unsigned NOT NULL default '0',
  usePlugin tinyint(1) unsigned NOT NULL default '0',
  autostartPlugin tinyint(1) unsigned NOT NULL default '0',
  promptPlugin tinyint(1) unsigned NOT NULL default '0',
  `Language` varchar(64) NOT NULL default '',
  `BackendCharset` varchar(22) NOT NULL default '',
  openFolders_tblObject text,
  openFolders_tblObjectFiles text,
  phpOnOff tinyint(1) unsigned NOT NULL default '0',
  seem_start_file int(11) unsigned NOT NULL default '0',
  seem_start_type enum('0','cockpit','document','object','weapp') NOT NULL default 'cockpit',
  seem_start_weapp varchar(255) NOT NULL default '',
  editorSizeOpt tinyint(1) unsigned NOT NULL default '0',
  editorWidth smallint unsigned NOT NULL default '0',
  editorHeight smallint unsigned NOT NULL default '0',
  debug_normal tinyint(1) unsigned NOT NULL default '0',
  debug_seem tinyint(1) unsigned NOT NULL default '0',
  editorFontname varchar(255) NOT NULL default '',
  editorFontsize tinyint(2) NOT NULL default '0',
  editorFont tinyint(1) unsigned NOT NULL default '0',
  default_tree_count smallint unsigned NOT NULL default '0',
  xhtml_show_wrong tinyint(1) unsigned NOT NULL default '0',
  xhtml_show_wrong_text tinyint(2) unsigned NOT NULL default '0',
  xhtml_show_wrong_js tinyint(2) unsigned NOT NULL default '0',
  xhtml_show_wrong_error_log tinyint(2) unsigned NOT NULL default '0',
  import_from varchar(255) NOT NULL default '',
  siteImportPrefs longtext NOT NULL,
  cockpit_amount_last_documents tinyint(2) unsigned NOT NULL default '3',
  cockpit_rss_feed_url text,
  use_jupload tinyint(1) unsigned NOT NULL default '1',
  juploadPath text,
  cockpit_dat text,
  cockpit_amount_columns tinyint(2) unsigned NOT NULL default '3',
  message_reporting tinyint(1) unsigned NOT NULL default '7',
  force_glossary_check tinyint(1) unsigned NOT NULL default '0',
  force_glossary_action tinyint(1) unsigned NOT NULL default '0',
  editorFontcolor varchar(255) NOT NULL,
  editorWeTagFontcolor varchar(255) NOT NULL,
  editorWeAttributeFontcolor varchar(255) NOT NULL,
  editorHTMLTagFontcolor varchar(255) NOT NULL,
  editorHTMLAttributeFontcolor varchar(255) NOT NULL,
  editorPiTagFontcolor varchar(255) NOT NULL,
  editorCommentFontcolor varchar(255) NOT NULL,
  specify_jeditor_colors tinyint(1) unsigned NOT NULL,
  editorMode enum('textarea','codemirror','codemirror2','java')  NOT NULL DEFAULT 'textarea',
  editorLinenumbers tinyint(1) unsigned NOT NULL default '1',
  editorCodecompletion tinyint(1) unsigned NOT NULL default '0',
  editorTooltips tinyint(1) unsigned NOT NULL default '1',
  editorTooltipFont tinyint(1) unsigned NOT NULL default '0',
  editorTooltipFontname varchar(255) NOT NULL default 'none',
  editorTooltipFontsize tinyint(2) NOT NULL default '-1',
  editorDocuintegration tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY (`userID`)
) ENGINE=MyISAM;
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblPrefs SET userID=1, FileFilter=0, openFolders_tblFile='', openFolders_tblTemplates='', DefaultTemplateID=0, DefaultStaticExt='.html', DefaultDynamicExt='.php', DefaultHTMLExt='.html', sizeOpt=0, weWidth=0, weHeight=0, usePlugin=0, autostartPlugin=0, promptPlugin=0, Language='English_UTF-8', openFolders_tblObject='', openFolders_tblObjectFiles='', phpOnOff=0, seem_start_file=0, seem_start_type='cockpit', editorSizeOpt=1, editorWidth=900, editorHeight=700, debug_normal=0, debug_seem=0, editorFontname='none', editorFontsize=-1, editorFont=0, default_tree_count=0, xhtml_show_wrong=0, xhtml_show_wrong_text=0, xhtml_show_wrong_js=0, xhtml_show_wrong_error_log=0, import_from='', siteImportPrefs='', cockpit_amount_last_documents=5, cockpit_rss_feed_url='http://www.webedition.org/de/feeds/aktuelles.xml', use_jupload=1, cockpit_dat='a:3:{i:0;a:2:{i:0;a:4:{i:0;s:3:"pad";i:1;s:4:"blue";i:2;i:1;i:3;s:26:"TWlzY2VsbGFuZW91cw==,30020";}i:1;a:4:{i:0;s:3:"mfd";i:1;s:5:"green";i:2;i:1;i:3;s:12:"1111;0;5;00;";}}i:1;a:2:{i:0;a:4:{i:0;s:3:"rss";i:1;s:6:"yellow";i:2;i:1;i:3;s:82:"aHR0cDovL3d3dy53ZWJlZGl0aW9uLm9yZy9kZS9yc3Mvd2ViZWRpdGlvbi54bWw=,111000,0,110000,1";}i:1;a:4:{i:0;s:3:"sct";i:1;s:3:"red";i:2;i:1;i:3;s:124:"open_document,new_document,new_template,new_directory,unpublished_pages;unpublished_objects,new_object,new_class,preferences";}}i:2;a:2:{i:0;a:2:{i:0;s:20:"d2ViRWRpdGlvbiBOZXdz";i:1;s:68:"aHR0cDovL3d3dy53ZWJlZGl0aW9uLmRlL2RlL05ld3MvbWVsZHVuZ2VuL3JzczIueG1s";}i:1;a:2:{i:0;s:28:"d2ViRWRpdGlvbiBAIFR3aXR0ZXI=";i:1;s:72:"aHR0cDovL3R3aXR0ZXIuY29tL3N0YXR1c2VzL3VzZXJfdGltZWxpbmUvMTY5MjI4MjAucnNz";}}};', cockpit_amount_columns=2, message_reporting=7, force_glossary_check=0, force_glossary_action=0, editorFontcolor='', editorWeTagFontcolor='', editorWeAttributeFontcolor='', editorHTMLTagFontcolor='', editorHTMLAttributeFontcolor='', editorPiTagFontcolor='', editorCommentFontcolor='', specify_jeditor_colors='0';

/* query separator */
CREATE TABLE ###TBLPREFIX###tblversionslog (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `timestamp` int(11) unsigned NOT NULL,
  `action` int(11) unsigned NOT NULL,
  `userID` int(11) unsigned NOT NULL,
  `data` longtext NOT NULL,
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM ;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblCategorys (
  ID int(11) unsigned NOT NULL auto_increment,
  Category varchar(64) NOT NULL default '',
  `Text` varchar(64) default NULL,
  Path varchar(255) default NULL,
  ParentID bigint(20) unsigned default NULL,
  IsFolder tinyint(1) unsigned  default NULL,
  Icon varchar(64) default NULL,
  Catfields longtext NOT NULL,
  PRIMARY KEY  (ID),
  KEY Path (Path)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblglossary (
  `ID` int(10) unsigned NOT NULL auto_increment,
  `Path` varchar(255) default NULL,
  `IsFolder` tinyint(1) unsigned default NULL,
  `Icon` enum('folder.gif','prog.gif') NOT NULL,
  `Text` varchar(255) NOT NULL default '',
  `Type` enum('abbreviation','acronym','foreignword','link','textreplacement') NOT NULL default 'abbreviation',
  `Language` varchar(5) NOT NULL default '',
  `Title` tinytext NOT NULL,
  `Attributes` text NOT NULL,
  `Linked` tinyint(1) unsigned NOT NULL default '0',
  `Description` text NOT NULL,
  `CreationDate` int(11) unsigned NOT NULL default '0',
  `ModDate` int(11) unsigned NOT NULL default '0',
  `Published` int(11) unsigned NOT NULL default '0',
  `CreatorID` bigint(20) unsigned NOT NULL default '0',
  `ModifierID` bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY  (`ID`),
  KEY valid (Language(5),Published)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblversions (
  `ID` bigint(20) unsigned NOT NULL auto_increment,
  `documentID` bigint(20) unsigned NOT NULL,
  `documentTable` varchar(64) NOT NULL,
  `documentElements` blob NOT NULL,
  `documentScheduler` blob NOT NULL,
  `documentCustomFilter` blob NOT NULL,
  `timestamp` int(11) unsigned NOT NULL,
  `status` enum('saved','published','unpublished','deleted') NOT NULL,
  `version` bigint(20) unsigned NOT NULL,
  `binaryPath` varchar(255) NOT NULL,
  `modifications` varchar(255) NOT NULL,
  `modifierID` bigint(20) unsigned NOT NULL,
  `IP` varchar(30) NOT NULL,
  `Browser` varchar(255) NOT NULL,
  `ContentType` varchar(32) NOT NULL,
  `Text` varchar(255) NOT NULL,
  `ParentID` int(11) unsigned NOT NULL,
  `Icon` varchar(64) NOT NULL,
  `CreationDate` int(11) unsigned NOT NULL,
  `CreatorID` bigint(20) unsigned NOT NULL,
  `Path` varchar(255) NOT NULL,
  `TemplateID` int(11) unsigned NOT NULL,
  `Filename` varchar(255) NOT NULL,
  `Extension` varchar(16) NOT NULL,
  `IsDynamic` tinyint(1) unsigned NOT NULL,
  `IsSearchable` tinyint(1) unsigned NOT NULL,
  `ClassName` varchar(64) NOT NULL,
  `DocType` smallint(6) NOT NULL,
  `Category` text NOT NULL,
  `RestrictOwners` tinyint(1) unsigned NOT NULL,
  `Owners` varchar(255) NOT NULL,
  `OwnersReadOnly` text NOT NULL,
  `Language` varchar(5) NOT NULL,
  `WebUserID` bigint(20) unsigned NOT NULL,
  `Workspaces` varchar(1000) NOT NULL,
  `ExtraWorkspaces` varchar(1000) NOT NULL,
  `ExtraWorkspacesSelected` varchar(1000) NOT NULL,
  `Templates` varchar(255) NOT NULL,
  `ExtraTemplates` varchar(255) NOT NULL,
  `MasterTemplateID` bigint(20) unsigned NOT NULL default '0',
  `TableID` bigint(20) unsigned NOT NULL,
  `ObjectID` bigint(20) unsigned NOT NULL,
  `IsClassFolder` tinyint(1) unsigned NOT NULL,
  `IsNotEditable` tinyint(1) unsigned NOT NULL,
  `Charset` varchar(64) NOT NULL,
  `active` tinyint(1) unsigned NOT NULL,
  `fromScheduler` tinyint(1) unsigned NOT NULL,
  `fromImport` tinyint(1) unsigned NOT NULL,
  `resetFromVersion` bigint(20) unsigned NOT NULL,
  `InGlossar` tinyint(1) unsigned NOT NULL,
  PRIMARY KEY  (`ID`),
  KEY documentID (documentID),
  KEY `timestamp` (`timestamp`,`CreationDate`),
  KEY `binaryPath` (`binaryPath`),
  KEY `version` (`version`)
) ENGINE=MyISAM ;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblTODO (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned default NULL,
  UserID int(11) unsigned NOT NULL default '0',
  account_id int(11) unsigned NOT NULL default '0',
  msg_type tinyint(4) unsigned NOT NULL default '0',
  obj_type tinyint(4) unsigned NOT NULL default '0',
  headerDate int(11) unsigned default NULL,
  headerSubject varchar(255) default NULL,
  headerCreator int(11) unsigned default NULL,
  headerAssigner int(11) unsigned default NULL,
  headerStatus tinyint(4) unsigned default NULL,
  headerDeadline int(11) unsigned default NULL,
  Priority tinyint(4) unsigned default NULL,
  Properties smallint(5) unsigned default NULL,
  MessageText text,
  Content_Type varchar(10) default NULL,
  seenStatus tinyint(3) unsigned NOT NULL default '0',
  tag tinyint(3) unsigned default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
###UPDATEONLY###DELETE FROM ###TBLPREFIX###tblTemporaryDoc WHERE Active=0;
/* query separator */
###UPDATEONLY###UPDATE ###TBLPREFIX###tblTemporaryDoc SET DocTable="tblFile" WHERE DocTable="###TBLPREFIX###tblFile";
/* query separator */
###UPDATEONLY###UPDATE ###TBLPREFIX###tblTemporaryDoc SET DocTable="tblObjectFiles" WHERE DocTable="###TBLPREFIX###tblObjectFiles";
/* query separator */
###UPDATEDROPCOL(ID,###TBLPREFIX###tblTemporaryDoc)###
/* query separator */
CREATE TABLE ###TBLPREFIX###tblTemporaryDoc (
  DocumentID bigint(20) unsigned NOT NULL default '0',
  DocumentObject longtext NOT NULL,
  DocTable enum('tblFile','tblObjectFiles') NOT NULL,
  UnixTimestamp int(10) unsigned NOT NULL default '0',
  Active tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY (`DocTable`,`DocumentID`,`Active`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMessages (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned default NULL,
  UserID int(11) unsigned default NULL,
  msg_type tinyint(4) unsigned NOT NULL default '0',
  obj_type tinyint(4) unsigned NOT NULL default '0',
  headerDate int(11) unsigned default NULL,
  headerSubject varchar(255) default NULL,
  headerUserID int(11) unsigned default NULL,
  headerFrom varchar(255) default NULL,
  headerTo varchar(255) default NULL,
  Priority tinyint(4) unsigned default NULL,
  seenStatus tinyint(4) unsigned NOT NULL default '0',
  MessageText text,
  tag tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY UserID (UserID),
  KEY `query` (`obj_type`,`msg_type`,`ParentID`,`UserID`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblCleanUp (
  ID int(11) unsigned NOT NULL auto_increment,
  Path varchar(255) NOT NULL default '',
  `Date` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  UNIQUE KEY Path (Path),
  KEY `Date` (`Date`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMsgFolders (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned default NULL,
  UserID int(11) unsigned NOT NULL default '0',
  account_id int(11) unsigned default NULL,
  msg_type tinyint(4) unsigned NOT NULL default '0',
  obj_type tinyint(4) unsigned NOT NULL default '0',
  Name varchar(255) NOT NULL default '',
  sortItem varchar(255) default NULL,
  sortOrder varchar(5) default NULL,
  Properties int(10) unsigned default NULL,
  tag tinyint(4) unsigned default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblMsgFolders VALUES (1,0,1,NULL,1,3,'Messages',NULL,NULL,1,NULL);
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblMsgFolders VALUES (2,1,1,NULL,1,5,'Sent',NULL,NULL,1,NULL);
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblMsgFolders VALUES (3,0,1,NULL,2,3,'Task',NULL,NULL,1,NULL);
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblMsgFolders VALUES (4,3,1,NULL,2,13,'Done',NULL,NULL,1,NULL);
/* query separator */
INSERT IGNORE INTO ###TBLPREFIX###tblMsgFolders VALUES (5,3,1,NULL,2,11,'rejected',NULL,NULL,1,NULL);
/* query separator */
###UPDATEONLY###UPDATE ###TBLPREFIX###tblnavigation SET SelectionType="doctype" WHERE SelectionType="docType"

/* query separator */

CREATE TABLE ###TBLPREFIX###tblnavigation (
  ID bigint(20) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  Path varchar(2000) NOT NULL default '',
  Published int(11) unsigned NOT NULL DEFAULT '1',
  Text varchar(800) NOT NULL default '',
  Display varchar(800) NOT NULL default '',
  ContentType enum('weNavigation') NOT NULL default 'weNavigation',
  Icon enum('folder.gif','link.gif') NOT NULL,
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  TitleField varchar(255) NOT NULL default '',
  IconID bigint(20) unsigned NOT NULL default '0',
  Selection enum('dynamic','nodynamic','static') NOT NULL,
  LinkID bigint(20) unsigned NOT NULL default '0',
  CurrentOnUrlPar tinyint(1) unsigned NOT NULL DEFAULT '0',
  CurrentOnAnker tinyint(1) unsigned NOT NULL DEFAULT '0',
  SelectionType enum('urlLink','category','catLink','classname','objLink','docLink','doctype') NOT NULL default 'docLink',
  FolderID bigint(20) unsigned NOT NULL default '0',
  DocTypeID smallint(6) unsigned NOT NULL,
  ClassID bigint(20) unsigned NOT NULL default '0',
  Categories text NOT NULL,
  Sort text NOT NULL,
  ShowCount tinyint(4) unsigned NOT NULL default '0',
  Ordn tinyint(4) unsigned NOT NULL default '0',
  Depended tinyint(1) unsigned NOT NULL default '0',
  WorkspaceID bigint(20) NOT NULL default '-1',
  CatParameter varchar(255) NOT NULL default '',
  Parameter varchar(255) NOT NULL default '',
  LinkSelection varchar(255) NOT NULL default '',
  Url varchar(255) NOT NULL default '',
  UrlID bigint(20) unsigned NOT NULL default '0',
  Charset varchar(255) NOT NULL default '',
  Attributes text NOT NULL,
  FolderSelection enum('docLink','objLink','urlLink') NOT NULL,
  FolderWsID bigint(20) unsigned NOT NULL default '0',
  FolderParameter varchar(255) NOT NULL default '',
  FolderUrl varchar(255) NOT NULL default '',
  LimitAccess tinyint(4) unsigned NOT NULL default '0',
  AllCustomers tinyint(4) unsigned NOT NULL default '1',
  ApplyFilter tinyint(4) unsigned NOT NULL default '0',
  Customers text NOT NULL,
  CustomerFilter text NOT NULL,
  BlackList text NOT NULL,
  WhiteList text NOT NULL,
  UseDocumentFilter tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY ParentID (ParentID),
  KEY LinkID (LinkID),
  KEY Path (Path)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblvoting (
  ID bigint(20) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  Path varchar(255) default NULL,
  IsFolder tinyint(1) unsigned default NULL,
  Icon varchar(255) default NULL,
  `Text` varchar(255) NOT NULL default '',
  PublishDate int(10) unsigned NOT NULL default '0',
  QASet text NOT NULL,
  QASetAdditions text,
  IsRequired tinyint(1) unsigned NOT NULL DEFAULT '0',
  AllowFreeText tinyint(1) unsigned NOT NULL DEFAULT '0',
  AllowImages tinyint(1) unsigned NOT NULL DEFAULT '0',
  AllowMedia tinyint(1) unsigned NOT NULL DEFAULT '0',
  AllowSuccessor tinyint(1) unsigned NOT NULL DEFAULT '0',
  AllowSuccessors tinyint(1) unsigned NOT NULL DEFAULT '0',
  Successor bigint(20) unsigned NOT NULL DEFAULT '0',
  Scores text NOT NULL,
  RevoteControl tinyint(1) unsigned NOT NULL default '0',
  RevoteTime int(11) default '0',
  Owners text NOT NULL,
  RestrictOwners tinyint(1) unsigned NOT NULL default '0',
  Revote longtext NOT NULL,
  RevoteUserAgent longtext NOT NULL,
  Valid bigint(20) unsigned NOT NULL default '0',
  Active tinyint(1) unsigned NOT NULL default '0',
  ActiveTime tinyint(1) unsigned NOT NULL default '0',
  FallbackIp tinyint(1) unsigned NOT NULL default '0',
  UserAgent tinyint(1) unsigned NOT NULL default '0',
  FallbackUserID tinyint(1) unsigned NOT NULL DEFAULT '0',
  Log tinyint(1) unsigned NOT NULL default '0',
  LogData longtext NOT NULL,
  RestrictIP tinyint(1) unsigned NOT NULL default '0',
  BlackList longtext NOT NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblDocTypes (
  ID smallint(6) unsigned NOT NULL auto_increment,
  DocType varchar(64) NOT NULL default '',
  Extension varchar(10) NOT NULL default '',
  ParentID int(11) unsigned NOT NULL default '0',
  ParentPath varchar(255) NOT NULL default '',
  SubDir int(11) unsigned NOT NULL default '0',
  TemplateID int(11) unsigned NOT NULL default '0',
  IsDynamic tinyint(1) unsigned NOT NULL default '0',
  IsSearchable tinyint(1) unsigned NOT NULL default '0',
  ContentTable varchar(32) NOT NULL default '',
  JavaScript text NOT NULL,
  Notify text NOT NULL,
  NotifyTemplateID int(11) unsigned NOT NULL default '0',
  NotifySubject varchar(64) NOT NULL default '',
  NotifyOnChange tinyint(1) unsigned NOT NULL default '0',
  LockID int(11) unsigned NOT NULL default '0',
  Templates varchar(255) NOT NULL default '',
  Deleted int(11) unsigned NOT NULL default '0',
  Category varchar(255) default NULL,
  Language varchar(5) default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblthumbnails (
  ID bigint(20) unsigned NOT NULL auto_increment,
  Name varchar(255) NOT NULL default '',
  `Date` int(11) unsigned NOT NULL default '0',
  Format char(3) NOT NULL default '',
  Height smallint(5) unsigned default NULL,
  Width smallint(5) unsigned default NULL,
  Ratio tinyint(1) unsigned NOT NULL default '0',
  Maxsize tinyint(1) unsigned NOT NULL default '0',
  Interlace tinyint(1) unsigned NOT NULL default '1',
  Fitinside smallint(5) unsigned NOT NULL default '0',
  `Directory` varchar(255) NOT NULL default '',
  Utilize tinyint(1) unsigned NOT NULL default '0',
  `Quality` tinyint unsigned NOT NULL DEFAULT  '8',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowDocStep (
  ID int(11) unsigned NOT NULL auto_increment,
  workflowDocID int(11) unsigned NOT NULL default '0',
  workflowStepID bigint(20) unsigned NOT NULL default '0',
  startDate bigint(10) unsigned NOT NULL default '0',
  finishDate bigint(10) unsigned NOT NULL default '0',
  `Status` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowTask (
  ID int(11) unsigned NOT NULL auto_increment,
  userID int(11) unsigned NOT NULL default '0',
  Edit int(11) unsigned NOT NULL default '0',
  Mail int(11) unsigned NOT NULL default '0',
  stepID int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWebUserAutoLogin (
  AutoLoginID varchar(64) NOT NULL default '',
  WebUserID bigint(20) unsigned NOT NULL default '0',
  LastIp varchar(40)NOT NULL DEFAULT '',
  LastLogin timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY  (AutoLoginID,WebUserID),
  KEY `LastLogin` (`LastLogin`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowDef (
  ID int(11) unsigned NOT NULL auto_increment,
  `Text` varchar(255) NOT NULL default '',
  `Type` bigint(20) unsigned NOT NULL default '0',
  Folders varchar(255) NOT NULL default '',
  DocType varchar(255) NOT NULL default '',
  Objects varchar(255) NOT NULL default '',
  ObjectFileFolders varchar(255) NOT NULL default '',
  Categories text NOT NULL,
  ObjCategories varchar(255) NOT NULL default '',
  `Status` tinyint(1) unsigned NOT NULL default '0',
  `EmailPath` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `LastStepAutoPublish` tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblhistory (
  ID bigint(20) unsigned NOT NULL auto_increment,
  DID bigint(20) unsigned NOT NULL default '0',
  DocumentTable varchar(64) NOT NULL default '',
  ContentType enum('image/*','text/html','text/webedition','text/weTmpl','text/js','text/css','text/htaccess','text/plain','folder','class_folder','application/x-shockwave-flash','video/quicktime','application/*','text/xml','object','objectFile') NOT NULL,
  ModDate TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
  Act enum('save') NOT NULL default 'save',
  UserName varchar(64) NOT NULL default '',
  PRIMARY KEY  (ID),
  KEY UserName (UserName,DocumentTable),
  KEY DID (DID,DocumentTable,ModDate)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblLock (
  ID bigint(20) unsigned NOT NULL default '0',
  UserID int(11) unsigned NOT NULL default '0',
  sessionID varchar(64) NOT NULL default '',
  lockTime datetime NOT NULL,
  tbl varchar(32) NOT NULL default '',
  PRIMARY KEY (ID,tbl),
  KEY UserID (UserID,sessionID),
  KEY lockTime (lockTime)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblbannerclicks (
  clickid bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  ID bigint(20) unsigned NOT NULL default '0',
  `Timestamp` int(10) unsigned default NULL,
  IP varchar(30) NOT NULL default '',
  Referer varchar(255) NOT NULL default '',
  DID bigint(20) unsigned NOT NULL default '0',
  Page varchar(255) NOT NULL default '',
  PRIMARY KEY (`clickid`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWebUserSessions (
  SessionID varchar(32) NOT NULL default '',
  SessionIp varchar(40)NOT NULL DEFAULT '',
  WebUserID bigint(20) unsigned NOT NULL default '0',
  WebUserGroup varchar(255) NOT NULL DEFAULT '',
  WebUserDescription varchar(255) NOT NULL DEFAULT '',
  Browser varchar(255) NOT NULL DEFAULT '',
  Referrer varchar(255) NOT NULL DEFAULT '',
  LastLogin timestamp NOT NULL DEFAULT '0000-00-00 00:00:00',
  LastAccess timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' ON UPDATE CURRENT_TIMESTAMP,
  PageID bigint(20) unsigned NOT NULL default '0',
  ObjectID bigint(20) unsigned NOT NULL DEFAULT '0',
  SessionAutologin tinyint(1) unsigned NOT NULL DEFAULT '0',
  PRIMARY KEY  (SessionID),
  KEY `WebUserID` (`WebUserID`),
  KEY `LastAccess` (`LastAccess`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblOrders (
  IntID int(11) unsigned NOT NULL auto_increment,
  IntOrderID int(11) unsigned default NULL,
  IntCustomerID int(11) unsigned default NULL,
  IntArticleID int(11) unsigned default NULL,
  IntQuantity float default NULL,
  DateOrder datetime default NULL,
  DateConfirmation datetime default NULL,
  DateCustomA datetime default NULL,
  DateCustomB datetime default NULL,
  DateCustomC datetime default NULL,
  DateShipping datetime default NULL,
  DateCustomD datetime default NULL,
  DateCustomE datetime default NULL,
  DatePayment datetime default NULL,
  DateCustomF datetime default NULL,
  DateCustomG datetime default NULL,
  DateCancellation datetime default NULL,
  DateCustomH datetime default NULL,
  DateCustomI datetime default NULL,
  DateCustomJ datetime default NULL,
  DateFinished datetime default NULL,
  MailOrder DATETIME NULL,
  MailConfirmation DATETIME NULL,
  MailCustomA DATETIME NULL,
  MailCustomB DATETIME NULL,
  MailCustomC DATETIME NULL,
  MailShipping DATETIME NULL,
  MailCustomD DATETIME NULL,
  MailCustomE DATETIME NULL,
  MailPayment DATETIME NULL,
  MailCustomF DATETIME NULL,
  MailCustomG DATETIME NULL,
  MailCancellation DATETIME NULL,
  MailCustomH DATETIME NULL,
  MailCustomI DATETIME NULL,
  MailCustomJ DATETIME NULL,
  MailFinished DATETIME NULL,
  Price varchar(20) default NULL,
  IntPayment_Type tinyint(4) unsigned default NULL,
  strSerial longtext NOT NULL,
  strSerialOrder longtext NOT NULL,
  PRIMARY KEY  (IntID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMsgAccounts (
  ID int(11) unsigned NOT NULL auto_increment,
  UserID int(11) unsigned default NULL,
  name varchar(255) NOT NULL default '',
  msg_type int(11) unsigned default NULL,
  deletable tinyint(4) unsigned NOT NULL default '0',
  uri varchar(255) default NULL,
  `user` varchar(255) default NULL,
  pass varchar(255) default NULL,
  update_interval smallint(5) unsigned NOT NULL default '0',
  ext varchar(255) default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblSchedule (
  DID bigint(20) unsigned NOT NULL default '0',
  Wann int(11) unsigned NOT NULL default '0',
  `lockedUntil` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  Was tinyint(1) unsigned NOT NULL default '0',
  ClassName enum('we_htmlDocument','we_webEditionDocument','we_objectFile') NOT NULL,
  SerializedData longblob,
  Schedpro longtext,
  `Type` tinyint(3) unsigned NOT NULL default '0',
  Active tinyint(1) unsigned default NULL,
  PRIMARY KEY (DID,ClassName,Active,Wann,Was,`Type`),
  KEY Wann (Wann,`lockedUntil`,Active)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblvotinglog (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `votingsession` varchar(255) NOT NULL,
  `voting` bigint(20) unsigned NOT NULL,
  `time` int(11) unsigned NOT NULL,
  `ip` varchar(255) NOT NULL,
  `agent` varchar(255) NOT NULL,
  `userid` bigint(20) unsigned NOT NULL DEFAULT '0',
  `cookie` tinyint(1) unsigned NOT NULL,
  `fallback` tinyint(1) unsigned NOT NULL,
  `status` tinyint(2) unsigned NOT NULL,
  `answer` varchar(255) NOT NULL,
  `answertext` text NOT NULL,
  `successor` bigint(20) unsigned NOT NULL DEFAULT '0',
  `additionalfields` text NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM ;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblNewsletterConfirm (
  confirmID varchar(96) NOT NULL default '',
  subscribe_mail varchar(255) NOT NULL default '',
  subscribe_html tinyint(1) unsigned NOT NULL default '0',
  subscribe_salutation varchar(255) NOT NULL default '',
  subscribe_title varchar(255) NOT NULL default '',
  subscribe_firstname varchar(255) NOT NULL default '',
  subscribe_lastname varchar(255) NOT NULL default '',
  lists text NOT NULL,
  expires bigint(20) unsigned NOT NULL default '0',
  PRIMARY KEY confirmID(confirmID(30)),
  KEY expires (expires),
  KEY subscribe (subscribe_mail(50),confirmID(30))
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblRecipients (
  ID bigint(20) unsigned NOT NULL auto_increment,
  Email varchar(255) NOT NULL default '',
  PRIMARY KEY  (ID),
  UNIQUE KEY Email (Email)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblMsgAddrbook (
  ID int(11) unsigned NOT NULL auto_increment,
  UserID int(11) unsigned default NULL,
  strMsgType varchar(255) default NULL,
  strID varchar(255) default NULL,
  strAlias varchar(255) NOT NULL default '',
  strFirstname varchar(255) default NULL,
  strSurname varchar(255) default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblErrorLog (
  ID int(11) unsigned NOT NULL auto_increment,
  `Type` enum('Error','Warning','Parse error','Notice','Core error','Core warning','Compile error','Compile warning','User error','User warning','User notice','Deprecated notice','User deprecated notice','Strict Error','unknown Error','SQL Error') NOT NULL,
  `Function` varchar(255) NOT NULL DEFAULT '',
  `File` varchar(255) NOT NULL DEFAULT '',
  `Line` mediumint(8) unsigned NOT NULL,
  `Text` text NOT NULL,
  `Backtrace` text NOT NULL,
  `Request` text NOT NULL,
  `Session` text NOT NULL,
  `Global` text NOT NULL DEFAULT '',
  `Server` text NOT NULL,
  `Date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  PRIMARY KEY (ID),
  KEY `Date` (`Date`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblTODOHistory (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned NOT NULL default '0',
  UserID int(11) unsigned NOT NULL default '0',
  fromUserID int(11) unsigned NOT NULL default '0',
  `Comment` text,
  Created int(11) unsigned default NULL,
  `action` int(10) unsigned default NULL,
  `status` tinyint(3) unsigned default NULL,
  tag tinyint(3) unsigned default NULL,
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblObject (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned NOT NULL default '0',
  strOrder text NOT NULL,
  `Text` varchar(255) NOT NULL default '',
  Icon varchar(64) NOT NULL default '',
  IsFolder tinyint(4) unsigned NOT NULL default '0',
  ContentType enum('object') NOT NULL default 'object',
  CreationDate int(11) unsigned NOT NULL default '0',
  ModDate int(11) unsigned NOT NULL default '0',
  Path varchar(255) NOT NULL default '',
  CreatorID bigint(20) unsigned NOT NULL default '0',
  ModifierID bigint(20) unsigned NOT NULL default '0',
  RestrictOwners tinyint(1) unsigned NOT NULL default '0',
  Owners varchar(255) NOT NULL default '',
  OwnersReadOnly text NOT NULL,
  RestrictUsers tinyint(1) unsigned NOT NULL default '0',
  Users varchar(255) NOT NULL default '',
  UsersReadOnly text NOT NULL,
  DefaultCategory text NOT NULL,
  DefaultParentID bigint(20) unsigned NOT NULL default '0',
  DefaultText varchar(255) NOT NULL default '',
  DefaultValues longtext NOT NULL,
  DefaultDesc varchar(255) NOT NULL default '',
  DefaultTitle varchar(255) NOT NULL default '',
  DefaultKeywords varchar(255) NOT NULL default '',
  DefaultUrl varchar(255) NOT NULL default '',
  DefaultUrlfield0 varchar(255) NOT NULL DEFAULT '_',
  DefaultUrlfield1 varchar(255) NOT NULL DEFAULT '_',
  DefaultUrlfield2 varchar(255) NOT NULL DEFAULT '_',
  DefaultUrlfield3 varchar(255) NOT NULL DEFAULT '_',
  DefaultTriggerID bigint(20) unsigned NOT NULL default '0',
  ClassName varchar(64) NOT NULL default '',
  Workspaces varchar(1000) NOT NULL default '',
  DefaultWorkspaces varchar(1000) NOT NULL default '',
  Templates varchar(255) NOT NULL default '',
  CacheType enum('','none','tag','document','full') NOT NULL default 'none',
  CacheLifeTime int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Path (Path),
  KEY IsFolder (IsFolder)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowDoc (
  ID int(11) unsigned NOT NULL auto_increment,
  workflowID int(11) unsigned NOT NULL default '0',
  documentID int(11) unsigned NOT NULL default '0',
  userID int(11) unsigned NOT NULL default '0',
  `Status` tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblvalidationservices (
  PK_tblvalidationservices int(11) unsigned NOT NULL auto_increment,
  category varchar(20) NOT NULL default '',
  name varchar(255) NOT NULL default '',
  host varchar(255) NOT NULL default '',
  path varchar(255) NOT NULL default '',
  method varchar(4) NOT NULL default '',
  varname varchar(255) NOT NULL default '',
  checkvia varchar(20) NOT NULL default '',
  additionalVars varchar(255) NOT NULL default '',
  ctype varchar(20) NOT NULL default '',
  fileEndings varchar(255) NOT NULL default '',
  active tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (PK_tblvalidationservices)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblformmaillog (
  id bigint(20) unsigned NOT NULL auto_increment,
  ip varchar(15) NOT NULL,
  unixTime int(11) unsigned NOT NULL,
  PRIMARY KEY  (id),
  KEY ipwhen (ip,unixTime)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblLink (
  DID int(11) unsigned NOT NULL default '0',
  CID int(11) unsigned NOT NULL default '0',
  `Type` varchar(16) NOT NULL default '',
  Name varchar(255) NOT NULL default '',
  DocumentTable enum('tblFile','tblTemplates') NOT NULL,
  PRIMARY KEY (CID),
  KEY DID (DID,DocumentTable),
  KEY Name (Name(4)),
  KEY `Type` (`Type`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblbannerviews (
  viewid bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  ID bigint(20) unsigned NOT NULL default '0',
  `Timestamp` int(10) unsigned default NULL,
  IP varchar(30) NOT NULL default '',
  Referer varchar(255) NOT NULL default '',
  DID bigint(20) unsigned NOT NULL default '0',
  Page varchar(255) NOT NULL default '',
  PRIMARY KEY (`viewid`)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblWorkflowDocTask (
  ID int(11) unsigned NOT NULL auto_increment,
  documentStepID bigint(20) unsigned NOT NULL default '0',
  workflowTaskID bigint(20) unsigned NOT NULL default '0',
  `Date` bigint(10) unsigned NOT NULL default '0',
  todoID bigint(20) unsigned NOT NULL default '0',
  `Status` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblObjectFiles (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Icon enum('class_folder.gif','folder.gif','objectFile.gif') NOT NULL,
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  ContentType enum('folder','objectFile') NOT NULL,
  CreationDate int(11) unsigned NOT NULL default '0',
  ModDate int(11) unsigned NOT NULL default '0',
  `Path` varchar(255) NOT NULL default '',
  Url varchar(255) NOT NULL default '',
  TriggerID bigint(20) unsigned NOT NULL default '0',
  CreatorID bigint(20) unsigned NOT NULL default '0',
  ModifierID bigint(20) unsigned NOT NULL default '0',
  RestrictOwners tinyint(1) unsigned NOT NULL default '0',
  Owners varchar(255) NOT NULL default '',
  OwnersReadOnly text NOT NULL,
  Workspaces varchar(1000) NOT NULL default '',
  ExtraWorkspaces varchar(1000) NOT NULL default '',
  ExtraWorkspacesSelected varchar(1000) NOT NULL default '',
  Templates varchar(255) NOT NULL default '',
  ExtraTemplates varchar(255) NOT NULL default '',
  TableID bigint(20) unsigned NOT NULL default '0',
  ObjectID bigint(20) unsigned NOT NULL default '0',
  Category text NOT NULL,
  ClassName enum('we_class_folder','we_objectFile') NOT NULL,
  IsClassFolder tinyint(1) unsigned NOT NULL default '0',
  IsNotEditable tinyint(1) unsigned NOT NULL default '0',
  Published int(11) unsigned NOT NULL default '0',
  IsSearchable tinyint(1) unsigned NOT NULL default '1',
  `Charset` varchar(64) default NULL,
  `Language` varchar(5) default NULL,
  WebUserID bigint(20) unsigned NOT NULL,
  PRIMARY KEY  (ID),
  KEY Path (Path),
  KEY WebUserID (WebUserID),
  KEY TableID (TableID),
  KEY Url (Url)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblbanner (
  ID bigint(20) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Path varchar(255) NOT NULL default '',
  Icon varchar(64) NOT NULL default '',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  CreatorID int(11) unsigned NOT NULL default '0',
  CreateDate int(10) unsigned NOT NULL default '0',
  ModifierID int(11) unsigned NOT NULL default '0',
  ModifyDate int(10) unsigned NOT NULL default '0',
  bannerID bigint(20) unsigned NOT NULL default '0',
  bannerUrl varchar(255) NOT NULL default '',
  bannerIntID bigint(20) unsigned NOT NULL default '0',
  IntHref tinyint(1) unsigned NOT NULL default '0',
  maxShow int(10) unsigned NOT NULL default '0',
  maxClicks int(10) unsigned NOT NULL default '0',
  IsDefault tinyint(1) unsigned NOT NULL default '0',
  clickPrice double NOT NULL default '0',
  showPrice double NOT NULL default '0',
  StartOk tinyint(1) unsigned NOT NULL default '0',
  EndOk tinyint(1) unsigned NOT NULL default '0',
  StartDate int(10) unsigned NOT NULL default '0',
  EndDate int(10) unsigned NOT NULL default '0',
  FileIDs varchar(255) NOT NULL default '',
  FolderIDs varchar(255) NOT NULL default '',
  CategoryIDs text NOT NULL,
  DoctypeIDs varchar(255) NOT NULL default '',
  IsActive tinyint(1) unsigned NOT NULL default '0',
  clicks int(10) unsigned NOT NULL default '0',
  views int(10) unsigned NOT NULL default '0',
  Customers varchar(255) NOT NULL default '',
  TagName varchar(255) NOT NULL default '',
  weight tinyint(2) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblTemplates (
  ID int(11) unsigned NOT NULL auto_increment,
  ParentID int(11) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Icon enum('folder.gif','we_template.gif') NOT NULL default 'we_template.gif',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  ContentType enum('folder','text/weTmpl') NOT NULL default 'text/weTmpl',
  CreationDate int(11) unsigned NOT NULL default '0',
  ModDate int(11) unsigned NOT NULL default '0',
  Path varchar(255) NOT NULL default '',
  Filename varchar(64) NOT NULL default '',
  Extension enum('','.tmpl') NOT NULL default '',
  ClassName varchar(64) NOT NULL default '',
  Deleted int(11) unsigned NOT NULL default '0',
  Owners varchar(255) default NULL,
  RestrictOwners tinyint(1) unsigned default NULL,
  OwnersReadOnly text,
  CreatorID bigint(20) unsigned NOT NULL default '0',
  ModifierID bigint(20) unsigned NOT NULL default '0',
  MasterTemplateID bigint(20) unsigned NOT NULL default '0',
  IncludedTemplates varchar(255) NOT NULL default '',
  CacheType enum('','none','tag','document','full') NOT NULL default 'none',
  CacheLifeTime int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY ParentID (ParentID,Filename(3)),
  KEY MasterTemplateID (MasterTemplateID),
  KEY IncludedTemplates (IncludedTemplates)
) ENGINE=MyISAM;

/* query separator */
###UPDATEONLY###UPDATE ###TBLPREFIX###tblTemplates SET Icon="we_template.gif" WHERE IsFolder=0;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblFailedLogins (
  ID  bigint(20) unsigned NOT NULL AUTO_INCREMENT,
  Username varchar(64) NOT NULL default '',
  IP varchar(40) NOT NULL default '',
  LoginDate timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,
  UserTable enum('tblUser','tblWebUser') NOT NULL,
  Servername varchar(150) NOT NULL,
  Port mediumint(8) NOT NULL,
  Script varchar(150) NOT NULL,
  PRIMARY KEY (`ID`),
  KEY IP (LoginDate,UserTable,IP),
  KEY user (LoginDate,Username)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblUser (
  ID int(10) unsigned NOT NULL auto_increment,
  ParentID bigint(20) unsigned NOT NULL default '0',
  `Text` varchar(255) NOT NULL default '',
  Path varchar(255) NOT NULL default '',
  Icon varchar(64) NOT NULL default '',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  `Type` tinyint(4) unsigned NOT NULL default '0',
  `First` varchar(255) NOT NULL default '',
  `Second` varchar(255) NOT NULL default '',
  Address varchar(255) NOT NULL default '',
  HouseNo varchar(11) NOT NULL default '',
  City varchar(255) NOT NULL default '',
  PLZ varchar(32) NOT NULL default '',
  State varchar(255) NOT NULL default '',
  Country varchar(255) NOT NULL default '',
  Tel_preselection varchar(11) NOT NULL default '',
  Telephone varchar(32) NOT NULL default '',
  Fax_preselection varchar(11) NOT NULL default '',
  Fax varchar(32) NOT NULL default '',
  Handy varchar(32) NOT NULL default '',
  Email varchar(255) NOT NULL default '',
  Description text NOT NULL,
  username varchar(255) NOT NULL default '',
  passwd varchar(255) NOT NULL default '',
  Permissions text NOT NULL,
  ParentPerms tinyint(4) unsigned NOT NULL default '0',
  Alias bigint(20) unsigned NOT NULL default '0',
  CreatorID bigint(20) unsigned NOT NULL default '0',
  CreateDate bigint(20) unsigned NOT NULL default '0',
  ModifierID bigint(20) unsigned NOT NULL default '0',
  ModifyDate bigint(20) unsigned NOT NULL default '0',
  Ping int(11) unsigned NOT NULL default '0',
  Portal varchar(255) NOT NULL default '',
  workSpace varchar(1000) NOT NULL default '',
  workSpaceDef varchar(1000) NOT NULL default '',
  workSpaceTmp varchar(1000) NOT NULL default '',
  workSpaceNav varchar(1000) NOT NULL default '',
  workSpaceObj varchar(1000) NOT NULL default '',
  workSpaceNwl varchar(1000) NOT NULL default '',
  ParentWs tinyint(4) unsigned NOT NULL default '0',
  ParentWst tinyint(4) unsigned NOT NULL default '0',
  ParentWsn tinyint(4) unsigned NOT NULL default '0',
  ParentWso tinyint(4) unsigned NOT NULL default '0',
  ParentWsnl tinyint(4) unsigned NOT NULL default '0',
  Salutation varchar(32) NOT NULL default '',
  LoginDenied tinyint(1) unsigned NOT NULL default '0',
  UseSalt tinyint(1) unsigned NOT NULL default '0',
  PRIMARY KEY  (ID),
  KEY Ping (Ping),
  KEY Alias (Alias),
  KEY username (username)
) ENGINE=MyISAM;
/* query separator */
###INSTALLONLY###INSERT INTO ###TBLPREFIX###tblUser VALUES (1,0,'admin','/admin','user.gif',0,0,'webEdition','','','','',0,'','','','','','','','','','admin','c0e024d9200b5705bc4804722636378a','a:55:{s:13:\"ADMINISTRATOR\";s:1:\"1\";s:18:\"NEW_WEBEDITIONSITE\";s:1:\"1\";s:10:\"NEW_GRAFIK\";s:1:\"1\";s:8:\"NEW_HTML\";s:1:\"1\";s:9:\"NEW_FLASH\";s:1:\"1\";s:6:\"NEW_JS\";s:1:\"1\";s:7:\"NEW_CSS\";s:1:\"1\";s:12:\"NEW_SONSTIGE\";s:1:\"1\";s:12:\"NEW_TEMPLATE\";s:1:\"1\";s:14:\"NEW_DOC_FOLDER\";s:1:\"1\";s:22:\"CHANGE_DOC_FOLDER_PATH\";s:1:\"0\";s:15:\"NEW_TEMP_FOLDER\";s:1:\"1\";s:17:\"CAN_SEE_DOCUMENTS\";s:1:\"1\";s:17:\"CAN_SEE_TEMPLATES\";s:1:\"1\";s:22:\"SAVE_DOCUMENT_TEMPLATE\";s:1:\"1\";s:17:\"DELETE_DOC_FOLDER\";s:1:\"1\";s:18:\"DELETE_TEMP_FOLDER\";s:1:\"1\";s:15:\"DELETE_DOCUMENT\";s:1:\"1\";s:15:\"DELETE_TEMPLATE\";s:1:\"1\";s:13:\"BROWSE_SERVER\";s:1:\"1\";s:12:\"EDIT_DOCTYPE\";s:1:\"1\";s:14:\"EDIT_KATEGORIE\";s:1:\"1\";s:7:\"REBUILD\";s:1:\"1\";s:6:\"EXPORT\";s:1:\"1\";s:6:\"IMPORT\";s:1:\"1\";s:9:\"NEW_GROUP\";s:1:\"1\";s:8:\"NEW_USER\";s:1:\"1\";s:10:\"SAVE_GROUP\";s:1:\"1\";s:9:\"SAVE_USER\";s:1:\"1\";s:12:\"DELETE_GROUP\";s:1:\"1\";s:11:\"DELETE_USER\";s:1:\"1\";s:7:\"PUBLISH\";s:1:\"1\";s:21:\"EDIT_SETTINGS_DEF_EXT\";s:1:\"1\";s:13:\"EDIT_SETTINGS\";s:1:\"1\";s:11:\"EDIT_PASSWD\";s:1:\"1\";s:12:\"NEW_CUSTOMER\";s:1:\"0\";s:15:\"DELETE_CUSTOMER\";s:1:\"0\";s:13:\"EDIT_CUSTOMER\";s:1:\"0\";s:19:\"SHOW_CUSTOMER_ADMIN\";s:1:\"0\";s:16:\"NEW_SHOP_ARTICLE\";s:1:\"0\";s:19:\"DELETE_SHOP_ARTICLE\";s:1:\"0\";s:15:\"EDIT_SHOP_ORDER\";s:1:\"0\";s:17:\"DELETE_SHOP_ORDER\";s:1:\"0\";s:15:\"EDIT_SHOP_PREFS\";s:1:\"0\";s:19:\"CAN_SEE_OBJECTFILES\";s:1:\"1\";s:14:\"NEW_OBJECTFILE\";s:1:\"1\";s:21:\"NEW_OBJECTFILE_FOLDER\";s:1:\"1\";s:17:\"DELETE_OBJECTFILE\";s:1:\"1\";s:15:\"CAN_SEE_OBJECTS\";s:1:\"0\";s:10:\"NEW_OBJECT\";s:1:\"0\";s:13:\"DELETE_OBJECT\";s:1:\"0\";s:12:\"NEW_WORKFLOW\";s:1:\"0\";s:15:\"DELETE_WORKFLOW\";s:1:\"0\";s:13:\"EDIT_WORKFLOW\";s:1:\"0\";s:9:\"EMPTY_LOG\";s:1:\"0\";}',0,0,0,0,0,0,1146233940,'','','','','','','',0,0,0,0,0,'',0,1);
/* query separator */
CREATE TABLE ###TBLPREFIX###tblLangLink (
  ID int(11) unsigned NOT NULL AUTO_INCREMENT,
  DID int(11) unsigned NOT NULL default '0',
  DLocale varchar(5) NOT NULL default '',
  IsFolder tinyint(1) unsigned NOT NULL default '0',
  IsObject tinyint(1) unsigned NOT NULL default '0',
  LDID int(11) unsigned NOT NULL default '0',
  Locale varchar(5) NOT NULL default '',
  DocumentTable enum('tblFile','tblObjectFile','tblDocTypes') NOT NULL,
  PRIMARY KEY (ID),
  UNIQUE KEY DID (DID,DLocale,IsObject,IsFolder,Locale,DocumentTable),
  UNIQUE KEY DLocale (DLocale,IsFolder,IsObject,LDID,Locale,DocumentTable),
  KEY LDID (LDID,DocumentTable,Locale)
) ENGINE=MyISAM;/* query separator */
CREATE TABLE ###TBLPREFIX###tblshopvats (
  id int(11) unsigned NOT NULL auto_increment,
  `text` varchar(255) NOT NULL default '',
  vat varchar(16) NOT NULL default '',
  standard tinyint(4) unsigned NOT NULL default '0',
  PRIMARY KEY  (id)
) ENGINE=MyISAM;
/* query separator */
CREATE TABLE ###TBLPREFIX###tblformmailblock (
  id bigint(20) unsigned NOT NULL auto_increment,
  ip varchar(15) NOT NULL,
  blockedUntil int(11) unsigned NOT NULL,
  PRIMARY KEY  (id),
  KEY ipblockeduntil (ip,blockedUntil)
) ENGINE=MyISAM;
/* query separator */
